// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.25.0
// source: services.sql

package db

import (
	"context"
)

const createService = `-- name: CreateService :one
INSERT INTO services (
    title,
    detail,
    service_item_id,
    appointment_id
) VALUES (
    $1, $2, $3, $4
) RETURNING id, title, detail, created_at, service_item_id, appointment_id
`

type CreateServiceParams struct {
	Title         string `json:"title"`
	Detail        string `json:"detail"`
	ServiceItemID int64  `json:"service_item_id"`
	AppointmentID int64  `json:"appointment_id"`
}

func (q *Queries) CreateService(ctx context.Context, arg CreateServiceParams) (Services, error) {
	row := q.db.QueryRowContext(ctx, createService,
		arg.Title,
		arg.Detail,
		arg.ServiceItemID,
		arg.AppointmentID,
	)
	var i Services
	err := row.Scan(
		&i.ID,
		&i.Title,
		&i.Detail,
		&i.CreatedAt,
		&i.ServiceItemID,
		&i.AppointmentID,
	)
	return i, err
}

const deleteService = `-- name: DeleteService :exec
DELETE FROM services WHERE id = $1
`

func (q *Queries) DeleteService(ctx context.Context, id int64) error {
	_, err := q.db.ExecContext(ctx, deleteService, id)
	return err
}

const getService = `-- name: GetService :one
SELECT id, title, detail, created_at, service_item_id, appointment_id FROM services
WHERE id = $1 LIMIT 1
`

func (q *Queries) GetService(ctx context.Context, id int64) (Services, error) {
	row := q.db.QueryRowContext(ctx, getService, id)
	var i Services
	err := row.Scan(
		&i.ID,
		&i.Title,
		&i.Detail,
		&i.CreatedAt,
		&i.ServiceItemID,
		&i.AppointmentID,
	)
	return i, err
}

const listServices = `-- name: ListServices :many
SELECT id, title, detail, created_at, service_item_id, appointment_id FROM services
ORDER BY id
LIMIT $1
OFFSET $2
`

type ListServicesParams struct {
	Limit  int64 `json:"limit"`
	Offset int64 `json:"offset"`
}

func (q *Queries) ListServices(ctx context.Context, arg ListServicesParams) ([]Services, error) {
	rows, err := q.db.QueryContext(ctx, listServices, arg.Limit, arg.Offset)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Services
	for rows.Next() {
		var i Services
		if err := rows.Scan(
			&i.ID,
			&i.Title,
			&i.Detail,
			&i.CreatedAt,
			&i.ServiceItemID,
			&i.AppointmentID,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const updateService = `-- name: UpdateService :exec
UPDATE services 
SET detail = $2
WHERE id = $1
`

type UpdateServiceParams struct {
	ID     int64  `json:"id"`
	Detail string `json:"detail"`
}

func (q *Queries) UpdateService(ctx context.Context, arg UpdateServiceParams) error {
	_, err := q.db.ExecContext(ctx, updateService, arg.ID, arg.Detail)
	return err
}
